package com.example.xmen_tp5_2324;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.xmen_tp5_2324.databinding.XMenBinding;

import java.util.List;

public class XMenAdapter extends RecyclerView.Adapter<XMenViewHolder>{
    // variable membre du type de l'interface
    private XMenAdapter.OnItemClickListener onItemClickListener;
    private List<XMen> liste;
    private final String TAG = "XMEN";
    public XMenAdapter(List liste){
        this.liste = liste;
    }
    @NonNull
    @Override
    public XMenViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        Log.i(TAG,"onCreateViewHolder");

        XMenBinding ui = XMenBinding.inflate(
                LayoutInflater.from(parent.getContext()),
                parent,
                false);
        return new XMenViewHolder(ui);
    }

    @Override
    public void onBindViewHolder(@NonNull XMenViewHolder holder, int position) {
        Log.i(TAG,"onBindViewHolder: " + position);
        holder.setXMen(liste.get(position));
        holder.setOnItemClickListener(onItemClickListener); // écouteur transmis au viewholder
    }

    @Override
    public int getItemCount() {
        return this.liste.size();
    }

    // interface publique d'écouteur
    public interface OnItemClickListener {
        void onItemClick(int position);
    }

    // setter
    public void setOnItemClickListener(OnItemClickListener onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
    }
}
