package com.example.xmen_tp5_2324;

import android.app.Application;
import android.content.res.Resources;
import android.content.res.TypedArray;

import java.util.*;

public class XMenApplication extends Application {

    // variable globale de l'application : la liste des XMen
    private final List<XMen> liste = new ArrayList<XMen>();

    // initialisation du contexte
    @Override public void onCreate() {
        super.onCreate();
        initListe();
    }

    public List<XMen> getListe() {
        return liste;
    }

    public void initListe(){
        // /!\ il faut préalablement vider la liste
        liste.clear();

        // accès aux ressources
        Resources res = getResources();
        final String[] noms = res.getStringArray(R.array.noms);
        final String[] alias = res.getStringArray(R.array.alias);
        final String[] descriptions = res.getStringArray(R.array.descriptions);
        final String[] pouvoirs = res.getStringArray(R.array.pouvoirs);
        TypedArray images = res.obtainTypedArray(R.array.idimages);

        // recopier les données dans la liste
        for (int i=0; i<noms.length; ++i) {
            XMen xm = new XMen(noms[i], alias[i], descriptions[i], pouvoirs[i], images.getResourceId(i, 0));
            liste.add(xm);
        }
        // libérer certaines ressources explicitement
        images.recycle();
    }



}
