package com.example.xmen_tp5_2324;
import android.view.View;
import android.view.ContextMenu;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.xmen_tp5_2324.databinding.XMenBinding;

public class XMenViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
    public static final int MENU_EDIT = 1;
    public static final int MENU_DELETE = 2;
    // même variable membre que dans l'adaptateur
    private XMenAdapter.OnItemClickListener onItemClickListener;
    private final XMenBinding ui;

    public XMenViewHolder(@NonNull XMenBinding ui)
    {
        super(ui.getRoot());
        this.ui = ui;
        // on associe cette classe comme écouteur de clic de l'item entier
        itemView.setOnClickListener(this);
        itemView.setOnCreateContextMenuListener(this::onCreateContextMenu);
    }
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenu.ContextMenuInfo menuInfo) {
        // position du X-Men concerné
        int position = getAdapterPosition();
        // titre du menu = nom du X-Men
        menu.setHeaderTitle(ui.nom.getText());
        // utiliser order (3e param) pour stocker la position du X-Men
        menu.add(0, MENU_EDIT, position, "Edit");
        menu.add(0, MENU_DELETE, position, "Delete");
    }

    public void setXMen(XMen xmen) {
        ui.nom.setText(xmen.getNom());
        ui.alias.setText(xmen.getAlias());
        ui.pouvoirs.setText(xmen.getPouvoirs());
        ui.description.setText(xmen.getDescription());
        ui.image.setImageResource(xmen.getIdImage());
    }
    public void onClick(View v) {
        if (onItemClickListener != null) // test par précaution
            onItemClickListener.onItemClick(getAbsoluteAdapterPosition());
    }

    // même setter que dans l'adaptateur
    public void setOnItemClickListener(XMenAdapter.OnItemClickListener onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
    }
}
